#include<iostream>

using namespace std;

const int MAXN = 5*(1e5) + 5;

struct node
{
    int up, down;
};

int Q, L;
string s;
long long n;

long long a[MAXN];

bool lazy[MAXN*4];
node tree[MAXN*4];

node help, help1;
node add(node A, node B)
{
    help.up = A.up + B.up;
    help.down = A.down + B.down;

    return help;
}

void build(int l, int r, int index)
{
    if(l==r)
    {
        help.up = 0;
        help.down = 0;

        if(s[l]=='+') help.up++;
        else help.down++;

        tree[index] = help;
        return;
    }

    build(l, (l+r)/2, 2*index);
    build((l+r)/2+1, r, 2*index+1);

    tree[index] = add(tree[2*index], tree[2*index+1]);
}

void updateLazy(int l, int r, int index)
{
    if(lazy[index]==true)
    {
        swap(tree[index].up, tree[index].down);

        if(l!=r)
        {
            lazy[2*index] ^= true;
            lazy[2*index+1] ^= true;
        }
    }

    lazy[index] = false;
}

node queryTree(int l, int r, int ql, int qr, int index)
{
    node help, help1;
    updateLazy(l, r, index);
    //cout << l << " " << r << " --> " << tree[index].up << " " << tree[index].down << '\n';

    if(l>=ql && r<=qr)
    {
        //cout << " + " << tree[index].up << " " << tree[index].down << '\n';
        return tree[index];
    }
    if(r<ql || l>qr)
    {
        help.up  = 0;
        help.down  = 0;

        return help;
    }

    help = queryTree(l, (l+r)/2, ql, qr, 2*index);
    help1 = queryTree((l+r)/2+1, r, ql, qr, 2*index+1);

    //cout << help.up << " " << help.down << " || " << help1.up << " " << help1.down << '\n';
    //cout << add(help, help1).up << " " << add(help, help1).down << '\n';

    return add(help, help1);
}

void updateTree(int l, int r, int ql, int qr, int index)
{
    updateLazy(l, r, index);

    if(l>=ql && r<=qr)
    {
        swap(tree[index].up, tree[index].down);

        if(l!=r)
        {
            lazy[2*index] ^= true;
            lazy[2*index+1] ^= true;
        }

        return;
    }
    if(r<ql || l>qr) return;

    updateTree(l, (l+r)/2, ql, qr, 2*index);
    updateTree((l+r)/2+1, r, ql, qr, 2*index+1);

    tree[index] = add(tree[2*index], tree[2*index+1]);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    char c;
    int l, r;

    node current;

    cin >> n >> Q;
    cin >> s;

    L = s.size();
    for(int i = 0;i<L;i++)
    {
        if(s[i]=='+') a[i] = 1;
        else a[i] = -1;
    }
    build(0, L-1, 1);

    for(int q = 0;q<Q;q++)
    {
        cin >> l >> r;
        updateTree(0, L-1, l-1, r-1, 1);

        current = queryTree(0, L-1, 0, L-1, 1);
        cout << ( current.up - current.down + 5LL*n )%n + 1 << '\n';
    }
}
