#include<iostream>
#include<vector>

using namespace std;

const int MAXN = 5*(1e5) + 5;

struct node
{
    int up, down;
};

string input;
int n, L = 0, Q;

vector <char> s;
vector <int> skipped;

bool lazy[MAXN*4];
node tree[MAXN*4];

node help, help1;
node add(node A, node B)
{
    help.up = A.up + B.up;
    help.down = A.down + B.down;

    return help;
}

void update(int l, int r)
{
    for(int i = l;i<=r;i++)
    {
        if(s[i]=='+') s[i] = '-';
        else if(s[i]=='-') s[i] = '+';
    }
}

void build(int l, int r, int index)
{
    if(l==r)
    {
        help.up = 0;
        help.down = 0;

        if(s[l]=='+') help.up++;
        else help.down++;

        tree[index] = help;
        return;
    }

    build(l, (l+r)/2, 2*index);
    build((l+r)/2+1, r, 2*index+1);

    tree[index] = add(tree[2*index], tree[2*index+1]);
}

int simulate()
{
    int channel = 1, last = 1, last1;

    //cout << a << '\n';
    for(int i = 0;i<L;i++)
    {
        //cout << "   " << channel << " " << a[i] << '\n';

        if(s[i]=='+')
        {
            last = channel;

            channel++;
            if(channel==n+1) channel = 1;
        }
        else if(s[i]=='-')
        {
            last = channel;

            channel--;
            if(channel==0) channel = n;
        }
        else
        {
            last1 = channel;

            channel = last;
            last = last1;
        }
    }

    return channel;
}

void updateLazy(int l, int r, int index)
{
    if(lazy[index]==true)
    {
        swap(tree[index].up, tree[index].down);

        if(l!=r)
        {
            lazy[2*index] ^= true;
            lazy[2*index+1] ^= true;
        }
    }

    lazy[index] = false;
}

node queryTree(int l, int r, int ql, int qr, int index)
{
    node help, help1;
    updateLazy(l, r, index);
    //cout << l << " " << r << " --> " << tree[index].up << " " << tree[index].down << '\n';

    if(l>=ql && r<=qr)
    {
        //cout << " + " << tree[index].up << " " << tree[index].down << '\n';
        return tree[index];
    }
    if(r<ql || l>qr)
    {
        help.up  = 0;
        help.down  = 0;

        return help;
    }

    help = queryTree(l, (l+r)/2, ql, qr, 2*index);
    help1 = queryTree((l+r)/2+1, r, ql, qr, 2*index+1);

    //cout << help.up << " " << help.down << " || " << help1.up << " " << help1.down << '\n';
    //cout << add(help, help1).up << " " << add(help, help1).down << '\n';

    return add(help, help1);
}

void updateTree(int l, int r, int ql, int qr, int index)
{
    updateLazy(l, r, index);

    if(l>=ql && r<=qr)
    {
        swap(tree[index].up, tree[index].down);

        if(l!=r)
        {
            lazy[2*index] ^= true;
            lazy[2*index+1] ^= true;
        }

        return;
    }
    if(r<ql || l>qr) return;

    updateTree(l, (l+r)/2, ql, qr, 2*index);
    updateTree((l+r)/2+1, r, ql, qr, 2*index+1);

    tree[index] = add(tree[2*index], tree[2*index+1]);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int ql, qr;
    int index, index1, initial = 0, streek;

    int add;
    int l, r, mid;

    bool fail = false;
    node current;

    cin >> n >> Q;
    cin >> input;

    index = 0;
    while(index<input.size() && input[index]=='o')
    {
        index++;
        initial++;
    }

    //cout << "OK" << '\n';

    add = 0;
    for(;index<input.size();)
    {
        streek = 0;
        //cout << "--" << index << " " << add << '\n';

        if(index==input.size()-1)
        {
            if(skipped.empty()==false) skipped.push_back(skipped[ skipped.size() - 1 ] + add);
            else
            {
                //cout << "OK " << add << '\n';
                skipped.push_back(add);

                add = 0;
            }

            s.push_back(input[index]);

            index++;
            continue;
        }
        else
        {
            if(input[index+1]!='o')
            {
                //cout << "OK" << '\n';
                //cout << "     " << add << '\n';

                if(skipped.empty()==false) skipped.push_back(skipped[ skipped.size() - 1] + add);
                else
                {
                    skipped.push_back(add);
                }

                s.push_back(input[index]);

                index++;

                add = 0;
                continue;
            }
            else
            {
                index1 = index + 1;
                while(index1<input.size() && input[index1]=='o')
                {
                    index1++;
                    streek++;
                }

                if( (index1-index-1)%2 == 0 )
                {
                    if(skipped.empty()==false)
                    {
                        skipped.push_back(skipped[ skipped.size() - 1 ] + add);
                    }
                    else
                    {
                        skipped.push_back(add);
                    }

                    s.push_back(input[index]);

                    index = index1;
                    //cout << "   " << index << '\n';

                    add = streek;
                    continue;
                }

                index = index1;
                //cout << "   " << index << '\n';
            }
        }

        if(skipped.empty()==false) add += 1 + streek;
        else
        {
            add += 1 + streek;
            //cout << streek << '\n';
        }
    }

    //for(int i = 0;i<s.size();i++) cout << s[i];
    //cout << '\n';

    //for(int i = 0;i<skipped.size();i++)
    //    cout << skipped[i] << " ";
    //cout << '\n';

    L = s.size();
    build(0, L-1, 1);

    for(int q = 0;q<Q;q++)
    {
        cin >> ql >> qr;
        if(L==0)
        {
            cout << "1" << '\n';
            continue;
        }


        fail = false;

        ql--;qr--;

        ql -= initial;
        qr -= initial;

        //cout << ql << '\n';
        if(ql>=skipped[ skipped.size() - 1 ] + skipped.size())
        {
            fail = true;
        }

        if(ql-skipped[0]<=0) ql = 0;
        else
        {
            l = 0;
            r = L - 1;

            while(l+1<r)
            {
                mid = (l+r)/2;

                if(skipped[mid]+mid>=ql) r = mid;
                else l = mid + 1;
            }

            if(skipped[l]+l>=ql) ql = l;
            else ql = r;
        }

        //cout << ql << '\n';

        //cout << "----" << '\n';

        if(qr-skipped[0]<0) fail = true;
        else
        {
            l = 0;
            r = L - 1;

            while(l+1<r)
            {
                mid = (l+r)/2;

                if(skipped[mid]+mid<=qr) l = mid;
                else r = mid - 1;
            }

            if(skipped[r]+r<=qr) qr = r;
            else qr = l;
        }

        //cout << qr << '\n';

        //cout << "fail: " << fail << '\n';
        if(fail==false)
        {
            updateTree(0, L-1, ql, qr, 1);
        }

        current = queryTree(0, L-1, 0, L-1, 1);
        cout << ( current.up - current.down + 5LL*n )%n + 1 << '\n';
    }
}
/*
10 5
++oo+-+o+
1 5
2 6
3 5
6 9
1 8
*/
