#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

const int MAXN = 1005, MAXK = 35;

struct edge
{
    int u, v;
    long long value;
};

bool operator <(const edge A, const edge B)
{
    if(A.value!=B.value) return A.value<B.value;
    if(A.u!=B.u) return A.u<B.u;

    return A.v<B.v;
}

int n, k, x, length;
bool a[MAXN][MAXK];

vector <edge> edges;
int treeSize[MAXN], parent[MAXN];

int index;
edge add;

void makeEdge(int l, int r)
{
    add.u = l;
    add.v = r;
    add.value = k + 1;

    index = 0;
    for(int i = 1;i<=k;i++)
    {
        if(a[l][i]==true && a[r][i]==true)
        {
            add.value = i;
            break;
        }
    }
}

int Find(int u)
{
    if(parent[u]==u) return u;

    parent[u] = Find(parent[u]);
    return parent[u];
}

void Union(int u, int v)
{
    if(treeSize[u]<treeSize[v]) swap(u, v);

    parent[v] = parent[u];
    treeSize[u] += treeSize[v];
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int u, v;
    long long answer = 0;

    cin >> n >> k;
    for(int i = 1;i<=n;i++)
    {
        cin >> length;
        for(int j = 0;j<length;j++)
        {
            cin >> x;
            a[i][x] = true;
        }
    }

    for(int i = 1;i<=n;i++)
    {
        for(int j = i+1;j<=n;j++)
        {
            makeEdge(i, j);
            edges.push_back(add);
        }
    }
    sort(edges.begin(), edges.end());

    for(int i = 1;i<=n;i++)
    {
        parent[i] = i;
        treeSize[i] = 1;
    }

    for(int i = 0;i<edges.size();i++)
    {
        u = Find(edges[i].u);
        v = Find(edges[i].v);

        if(u!=v)
        {
            Union(u, v);
            answer += edges[i].value;
        }
    }

    cout << answer << '\n';
}
/*
3 6
3 1 2 3
3 3 4 5
3 4 5 6
*/
