#include<iostream>
using namespace std;
const int maxl = 1000000;
int n, q;
string s;
int value[maxl];
int next_symb[maxl];

int tree[2 * maxl];
bool for_update[2 * maxl];

void build_tree(int i, int f, int t) /// [}
{
    if(f == t)  return;
    for_update[i] = false;
    if(f + 1 == t)
    {
        tree[i] = value[f];
        //cout << f << " " << t << " = " <<tree[i] << endl;
        return;
    }
    int m = (f + t) / 2;
    build_tree(i * 2 + 1, f, m);
    build_tree(i * 2 + 2, m, t);
    tree[i] = tree[i * 2 + 1] + tree[i * 2 + 2];
    //cout << f << " " << t << " = " <<tree[i] << endl;
}
void update(int i, int f, int t, int tf, int tt)
{
    if(f == t)
    {
        //cout << "a";
        return;
    }
    if(t <= tf || f >= tt)
    {
        //cout << "b";
        return;
    }
    if(tf <= f && t <= tt)
    {
        tree[i] *= -1;
        for_update[i] ^= 1;
        //cout << "~ " << f << " " << t << " " << 2 * tree[i] << endl;
        return;
    }
    int m = (f + t) / 2;
    int change = 0;
    if(!for_update[i])
    {
        update(i * 2 + 1, f, m, tf, tt);
        update(i * 2 + 2, m, t, tf, tt);
    } else {
        update(i * 2 + 1, f, m, tt, s.size());
        update(i * 2 + 2, m, t, tt, s.size());
        update(i * 2 + 1, f, m, 0, tf);
        update(i * 2 + 2, m, t, 0, tf);
    }
    for_update[i] = 0;
    tree[i] = tree[i * 2 + 1] + tree[i * 2 + 2];
    //cout << "~~ " << f << " " << t << " " << change << endl;
    return ;
}

int normalize(int a)
{
    return ((a % n) + n) % n + 1;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> q;
    cin >> s;
    for(int i = 0; i < s.size(); i ++)
    {
        if(s[i] == '+') value[i] = 1;
        if(s[i] == '-') value[i] = -1;
        if(s[i] == 'o') value[i] = -value[i - 1];
    }
    int ns = s.size();
    for(int i = s.size() - 1; i >= 0; i --)
    {
        if(s[i] != 'o') ns = i;
        next_symb[i] = ns;
    }

    build_tree(0, 0, s.size());
    //cout << tree[0];
    int ans = tree[0];
    //cout << "\n ans: " << normalize(tree[0]) << endl;
    for(int i = 0; i < q; i ++)
    {
        int f, t;
        cin >> f >> t;
        f --;
        t --;
        /// all o!!!
        t = next_symb[t];
        f = next_symb[f];
        //cout << "!!! " << f << " " << t + 1 << endl;
        update(0, 0, s.size(), f, t + 1);
        cout << normalize(tree[0]) << "\n";
    }
}
/*
10 2
+--++
1 2
2 5
*/

/*
8 3
+o-+o+
3 5
1 6
1 3
*/

/*
5 2
++oo
3 4
2 3
*/
