#include<iostream>
#include<vector>
#include<queue>
using namespace std;

#define edge pair<int,pair<int,int> >

const int maxn = 1100;
vector<int> kval[maxn];
int par[maxn];
int sz[maxn];

int n, k;

int min_cost(int i, int j)
{
    int a = 0, b = 0;
    while(a < kval[i].size() && b < kval[j].size())
    {
        if(kval[i][a] == kval[j][b])
        {
            return kval[i][a];
        }
        if(kval[i][a] < kval[j][b])
        {
            a ++;
        } else {
            b ++;
        }
    }
    return k + 1;
}

int get_par(int i)
{
    if(par[i] != i)
    {
        par[i] = get_par(par[i]);
    }
    return par[i];
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k;
    for(int i = 0; i < n; i ++)
    {
        int l;
        cin >> l;
        for(int j = 0; j < l; j ++)
        {
            int x;
            cin >> x;
            kval[i].push_back(x);
        }
        par[i] = i;
        sz[i] = 1;
    }
    priority_queue< edge > q;
    for(int i = 0; i < n; i ++)
    {
        for(int j = i + 1; j < n; j ++)
        {
            //cout << i << " " << j << " = " << min_cost(i,j) << endl;
            q.push(make_pair(-min_cost(i,j), make_pair(i, j)));
        }
    }
    int ans = 0;
    while(!q.empty())
    {
        edge e = q.top();
        e.first *= -1;
        q.pop();
        int i = e.second.first, j = e.second.second;
        //cout << i << " " << j << endl;
        if(get_par(i) != get_par(j))
        {
            //cout << "getting " << i << " " << j << " = " << e.first << endl;
            ans += e.first;

            int pc = par[i];
            //for(int l = 0; l < n; l ++) if(par[l] == pc)    par[l] = par[j];
            if(sz[par[i]] < sz[par[j]])
            {
                sz[par[j]] += sz[par[i]];
                par[par[i]] = par[j];
            }
            else
            {
                sz[par[i]] += sz[par[j]];
                par[par[j]] = par[i];
            }
        }
    }
    cout << ans;
}

/*
3 6
3 1 2 3
3 3 4 5
3 4 5 6
*/
/*
4 2
1 1
2 0 2
1 2
1 1
*/
