#include <iostream>
#include <algorithm>

int n, q;
std::string s;
const int MAX_L = 5*100000 + 10;

void change(int a, int b) {
	for(int i = a;i <= b;i ++) {
		if(s[i] == '+') s[i] = '-';
		else if(s[i] == '-') s[i] = '+';
	}
}

int eval() {
	int curr = 1;

	for(auto c : s) {
		if(c == '+') {
			curr += 1;
			if(curr > n) curr = 1;
		}
		if(c == '-') {
			curr -= 1;
			if(curr < 1) curr = n;
		}
	}

	return curr;
}

int next_alive[MAX_L];
int prev_alive[MAX_L];

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n >> q >> s;
	for(int i = 0;i < n;i ++) {
		next_alive[i] = prev_alive[i] = (1<<30);
	}

	std::string s2;

	int streak = 0;
	std::vector<int> idxs;
	for(int i = s.size()-1;i >= 0;i --) {
		if(s[i] == 'o') {
			streak ++;
		} else {
			if(streak == 0) {
				s2.push_back(s[i]);
				idxs.push_back(i);
				continue;
			}
			if(streak % 2 == 0) {
				s2.push_back(s[i]);
				idxs.push_back(i);
			}
			streak = 0;
		}
	}

	std::reverse(s2.begin(), s2.end());
	std::reverse(idxs.begin(), idxs.end());
	for(int i = 0;i < idxs.size();i ++) {
		next_alive[idxs[i]] = prev_alive[idxs[i]] = i;
	}
	s = s2;

	next_alive[n-1] = s.size() - 1;
	for(int i = n-2;i >= 0;i --) {
		if(next_alive[i] == (1<<30)) {
			next_alive[i] = next_alive[i+1];
		}
	}

	prev_alive[0] = 0;
	for(int i = 1;i < n;i ++) {
		if(prev_alive[i] == (1<<30)) {
			prev_alive[i] = prev_alive[i-1];
		}
	}

	/*
	std::cout << s << std::endl;
	for(auto x : idxs) std::cout << x << ' ';
	std::cout << std::endl;
	*/

	for(int i = 0;i < q;i ++) {
		int a, b;
		std::cin >> a >> b;
		a --;
		b --;
		a = next_alive[a];
		b = prev_alive[b];
		//std::cout << "change " << a << ' ' << b << std::endl;
		change(a, b);
		std::cout << eval() << '\n';
	}

	return 0;
}
