#include <iostream>
#include <algorithm>

int n, q;
std::string s;
const int MAX_L = 5*100000 + 10;

int tree[MAX_L * 8];
bool ch[MAX_L * 8];
int offset;

int build(int idx, int l, int r) {
	if(idx >= r) return 0;
	ch[idx] = false;
	if(offset <= idx and idx < offset+s.size()) {
		int v = 1;
		if(s[idx-offset] == '-') v = -1;
		return tree[idx] = v;
	} else {
		return tree[idx] = build(idx*2+0, l, r) + build(idx*2+1, l, r);
	}
}

int tl, tr;
int change(int idx, int l, int r) {
	//std::cout << "here " << idx << ' ' << l << ' ' << r << std::endl;
	if(idx >= offset * 2) return 0;

	if(ch[idx]) {
		//std::cout << "chng " << idx << std::endl;
		tree[idx] = -tree[idx];
		ch[idx] = false;
		ch[idx*2+0] = !ch[idx*2+0];
		ch[idx*2+1] = !ch[idx*2+1];
	}

	if(l >= tr) return tree[idx];
	if(r <= tl) return tree[idx];

	if(l >= tl and r <= tr) {
		//std::cout << "got " << idx << std::endl;
		tree[idx] = -tree[idx];
		ch[idx*2+0] = !ch[idx*2+0];
		ch[idx*2+1] = !ch[idx*2+1];
		return tree[idx];
	}

	const int m = (l+r) / 2;
	return tree[idx] = change(idx*2+0, l, m) + change(idx*2+1, m, r);
}

void change(int a, int b) {
	for(int i = a;i <= b;i ++) {
		if(s[i] == '+') s[i] = '-';
		else if(s[i] == '-') s[i] = '+';
	}
}

int next_alive[MAX_L];
int prev_alive[MAX_L];

void print_tr() {
	return;
	std::cout << offset << std::endl;
	for(int i = 0;i <= offset*2;i ++) {
		std::cout << i << '\t';
	}
	std::cout << std::endl;
	for(int i = 0;i <= offset*2;i ++) {
		std::cout << tree[i] << '\t';
	}
	std::cout << std::endl;
	for(int i = 0;i <= offset*2;i ++) {
		std::cout << ch[i] << '\t';
	}
	std::cout << std::endl;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n >> q >> s;
	for(int i = 0;i < n;i ++) {
		next_alive[i] = prev_alive[i] = (1<<30);
	}

	std::string s2;

	int streak = 0;
	std::vector<int> idxs;
	for(int i = s.size()-1;i >= 0;i --) {
		if(s[i] == 'o') {
			streak ++;
		} else {
			if(streak == 0) {
				s2.push_back(s[i]);
				idxs.push_back(i);
				continue;
			}
			if(streak % 2 == 0) {
				s2.push_back(s[i]);
				idxs.push_back(i);
			}
			streak = 0;
		}
	}

	std::reverse(s2.begin(), s2.end());
	std::reverse(idxs.begin(), idxs.end());
	for(int i = 0;i < idxs.size();i ++) {
		next_alive[idxs[i]] = i;
		prev_alive[idxs[i]] = i;
	}
	s = s2;


	if(s.size() == 0) {
		for(int i = 0;i < q;i ++) {
			std::cout << "1\n";
		}
		return 0;
	}
	/*
	for(int i = 0;i < n;i ++) std::cout << next_alive[i] << ' ';
	std::cout << std::endl;
	for(int i = 0;i < n;i ++) std::cout << prev_alive[i] << ' ';
	std::cout << std::endl;
	*/

	//next_alive[n-1] = s.size() - 1;
	//if(next_alive[n-1] == (1<<30)) next_alive[n-1] = s.size();
	//if(next_alive[n-1] == (1<<30)) next_alive[n-1] = idxs[s.size()-1];

	for(int i = n-2;i >= 0;i --) {
		if(next_alive[i] == (1<<30)) {
			next_alive[i] = next_alive[i+1];
		}
	}

	for(int i = 0;i < idxs[0];i ++) prev_alive[i] = -1;
	for(int i = 1;i < n;i ++) {
		if(prev_alive[i] == (1<<30)) {
			prev_alive[i] = prev_alive[i-1];
		}
	}

	/*
	std::cout << s << std::endl;
	for(auto x : idxs) std::cout << x << ' ';
	std::cout << std::endl;

	for(int i = 0;i < n;i ++) std::cout << next_alive[i] << ' ';
	std::cout << std::endl;
	for(int i = 0;i < n;i ++) std::cout << prev_alive[i] << ' ';
	std::cout << std::endl;
	*/

	offset = 1;
	while(offset < s.size()) offset *= 2;

	build(1, offset, offset*2);

	print_tr();

	for(int i = 0;i < q;i ++) {
		int a, b;
		std::cin >> a >> b;
		a --;
		b --;
		tl = next_alive[a] + offset;
		tr = prev_alive[b] + offset + 1;
		//std::cout << "change " << tl << ' ' << tr << std::endl;
		change(1, offset, offset*2);
		//std::cout << "=====================" << std::endl;
		//print_tr();
		int r = n + tree[1];
		r %= n;
		r ++;
		std::cout << r << '\n';
	}

	return 0;
}
