#include <iostream>
#include <algorithm>
#include <queue>

const int MAX_N = 1000 + 1;
bool kvalif[MAX_N][33];
int n, k;

int dist[MAX_N][MAX_N];

int calc(int from, int to) {
	int ans = k+1;
	for(int i = 1;i <= k;i ++) {
		if(kvalif[from][i] and kvalif[to][i]) {
			ans = i;
			break;
		}
	}
	dist[from][to] = true;
	dist[to][from] = true;
	return ans;
}

int parent[MAX_N];
int find(int a) {
	if(parent[a] == a) return a;
	return parent[a] = find(parent[a]);
}

void unite(int a, int b) {
	parent[find(a)] = find(b);
}

int main() {
	//std::ios_base::sync_with_stdio(false);
	//std::cin.tie(nullptr);
	std::cin >> n >> k;

	for(int i = 0;i < n;i ++) {
		parent[i] = i;
		for(int j = 0;j < n;j ++) dist[i][j] = (1<<30);
	}

	/*
	while(true) {
		int a, b, c;
		std::cin >> a >> b >> c;
		if(a == 0) std::cout << find(b) << std::endl;
		else unite(b, c);
		for(int i = 0;i < 5;i ++) {
			std::cout << parent[i] << std::endl; }
	}
	*/

	for(int i = 0;i < n;i ++) {
		int r;
		std::cin >> r;
		for(int j = 0;j < r;j ++) {
			int id;
			std::cin >> id;
			kvalif[i][id] = true;
		}
	}


	std::priority_queue<std::pair<int, std::pair<int, int>>> edges;
	for(int i = 0;i < n;i ++) {
		for(int j = 0;j < n;j ++) {
			if(i != j and dist[i][j] == (1<<30)) {
				const int d = calc(i, j);
				edges.push({-d, {i, j}});
			}
		}
	}

	int ans = 0;

	while(edges.size()) {
		auto curr = edges.top();
		edges.pop();
		/*
		std::cout << "WTF " << curr.first << ' '
		<< curr.second.first << ' ' << curr.second.second
	   	<< std::endl;
		*/

		const int pa = find(curr.second.first);
		const int pb = find(curr.second.second);

		if(pa == pb) {
		   	continue;
		}

		ans += -curr.first;
		parent[pa] = pb;
		//unite(pa, pb);
		//unite(curr.second.first, curr.second.second);
	}

	std::cout << ans << std::endl;
	return 0;
}
