#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int rooms [1024];
int mat [1024][1024];
long long answer = 0;
int n, k;

int parent [1024];

int Find (int a)
{
    if (parent [a] == a)
        return a;
    return parent [a] = Find (parent [a]);
}

void Union (int a, int b)
{
    parent [Find (a)] = Find (b);
}

struct edge
{
    int s, e, w;
    edge (int a, int b, int c)
    {
        s = a; e = b; w = c;
    }
    bool operator < (const edge& e) const
    {
        return w < e.w;
    }
};

int main ()
{
	cin.tie (nullptr);
	ios::sync_with_stdio (false);
	cin >> n >> k;
	for (int i = 0 ; i < n ; i ++)
	{
        parent [i] = i;
		int a;
		cin >> a;
        for (int j = 0 ; j < a ; j ++)
        {
            int b;
            cin >> b; b --;
            rooms [i] = (rooms [i] | (1 << b));
        }
	}
	vector < edge > edges;
	for (int i = 0 ; i < n ; i ++)
	{
        for (int j = i + 1 ; j < n ; j ++)
        {
            int t = (rooms [i] & rooms [j]);
            for (int i = 0 ; i < 32 ; i ++)
                if ((t & (1 << i)) != 0)
                    t = i + 1;
            if (t == 0)
                t = k + 1;
            mat [i][j] = mat [j][i] = t;
            edges.push_back(edge (i, j, t));
        }
    }
    sort (edges.begin(), edges.end ());
    int cost = 0;
    for (auto& x : edges)
    {
        if (Find (x.s) != Find (x.e))
        {
            Union (x.s, x.e);
            cost += x.w;
            cout << x.s << " " << x.e << " " << x.w << endl;
        }
    }
    cout << cost << endl;
}

