#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n, k;
string commands;

void rotate (int s, int e)
{
	for (int i = s ; i <= e ; i ++)
		if (commands [i] == '+')
			commands [i] = '-';
		else if (commands [i] == '-')
			commands [i] = '+';
}

int calc ()
{
	int prev_channel = -1;
	int channel = 0;
	for (auto& x : commands)
	{
		if (x == 'o')
		{
			swap (prev_channel, channel);
		}
		else if (x == '+')
		{
			prev_channel = channel;
			channel = (channel + 1 + n) % n;
		}
		else if (x == '-')
		{
			prev_channel = channel;
			channel = (channel - 1 + n) % n;
		}
		//cout << prev_channel << " " << channel << endl;
	}
	return channel + 1;
}

int main ()
{
	cin.tie (nullptr);
	ios::sync_with_stdio (false);	
	cin >> n >> k;
	cin >> commands;
	for (int i = 0 ; i < k ; i ++)
	{
		int a, b;
		cin >> a >> b; a --; b --;
		rotate (a, b);
		cout << calc () << endl;	
	}
}
