#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long n, k;
string commands;

struct bit
{
	vector < pair < int, bool > > v;
private:
	void _update (int a, int ind = 0, int lvl = 0)
	{
		if (a < v [0].first)
			v [a * 2].second = v [a * 2 + 1].second = true;
		int new_value = -v [a].first;
		int diff = new_value - v [a].first;
		while (a > 0)
		{
			v [a].first += diff;
			a /= 2;
		}
	}
public:
	bit (int* a, int n)
	{
		int elements = 1;
		for ( ; elements < n ; elements *= 2) {}
		v.resize (elements * 2);
		for (int i = 0 ; i < elements ; i ++)
			v [i + elements] = {a [i], false};
		for (int i = elements - 1; i >= 1 ; i --)
			v [i] = {v [2 * i].first + v [2 * i + 1].first, false};
		v [0] = {elements, false};
	}
	
	void checked_update (int a, int b)
	{
		if (commands [a] == 'o')
			checked_update (a + 1, b);
		else if (commands [b + 1] == 'o')
		{
			update (a, b);
			_update (v [0].first + b + 1, -v [v [0].first + b + 1].first);
		}
		else
		{
			update (a, b);
		}	
		
	}
	
	void update (int a, int b, int ind = 1, int lvl = 0)
	{
		if (v [ind].second == true)
		{
			if (ind < v [0].first)
				v [ind * 2].second = v [ind * 2 + 1].second = true;
			v [ind].first *= -1;
		}
		int t = ind - (1 << (lvl));
		//cout << t << " " << ind << " " << lvl << endl;
		int s = t * (v.size () / 2 / (1 << lvl));
		int e = (t + 1) * (v.size () / 2 / (1 << lvl)) - 1;
	
		//cout << "mission: " << a << " " << b << " / " << s << " " << e << endl;
		//if (a < 0 or b < 0 or s < 0 or e < 0)
		//	return;
		int mid = (s + e) / 2;
		if (a == s and b == e)
		{
			//v [ind].first = -v [ind].first;
			_update (ind);
		}
		else if (s <= a and b <= mid)
		{
			//cout << "left" << endl;
			update (a, b, ind * 2, lvl + 1);
		}
		else if (s <= a and a <= mid and mid < b)
		{
			//cout << "left" << endl;
			update (a, mid, ind * 2, lvl + 1);
			//cout << "right" << endl;
			update (mid + 1, b, ind * 2 + 1, lvl + 1);
		}
		else if (mid < a and b <= e)
		{
			//cout << "right" << endl;
			update (a, b, ind * 2 + 1, lvl + 1);
		}
		//else
			//cout << "mission failed: " << a << " " << b << " / " << s << " " << e << endl;
	}
	int get_top () const
	{
		return v [1].first;
	}
};

int change [500000];

int mabs (long long  a)
{
	return (a + n * n) % n;
}

int mround (long long a)
{
	if (a <= -n)
		return a + n;
	if (a >= n)
		return a - n;
	return a;
}

namespace old_one {
	void rotate (int s, int e)
	{
		/*
		for (int i = s ; i <= e ; i ++)
			if (commands [i] == '+')
				commands [i] = '-';
			else if (commands [i] == '-')
				commands [i] = '+';
		*/
		int start_change = ((s == 0) ? 0 : change [s - 1]);
		int big_change = change [e + 1] - change [e];
		for (int i = s ; i <= e ; i ++)
			change [i] = mabs (mround (-(change [i] - 2 * start_change)));
		big_change = change [e] + big_change - change [e + 1];
		for (size_t i = e + 1 ; i < commands.size () ; i ++)
			change [i] = mabs (mround (change [i]) + big_change);
	}

	int calc ()
	{
		/*
		int prev_channel = -1;
		int channel = 0;
		for (auto& x : commands)
		{
			if (x == 'o')
			{
				swap (prev_channel, channel);
			}
			else if (x == '+')
			{
				prev_channel = channel;
				channel = (channel + 1 + n) % n;
			}
			else if (x == '-')
			{
				prev_channel = channel;
				channel = (channel - 1 + n) % n;
			}
			//cout << prev_channel << " " << channel << endl;
		}*/
		return mabs (1 + change [commands.size () - 1]);
	}
}

int main ()
{
	cin.tie (nullptr);
	ios::sync_with_stdio (false);	
	cin >> n >> k;
	cin >> commands;
	for (size_t i = 0 ; i < commands.size () ; i ++)
	{
		if (commands [i] == '+')
		{
			change [i] = 1;
		}
		else if (commands [i] == '-')
		{
			change [i] = -1;
		}
		else if (commands [i] == 'o')
		{
			change [i] = -change [i - 1];
		}
	}
	bit my_bit = bit (change, commands.size ());
	/*
	for (size_t i = 0 ; i < commands.size () ; i ++)
		cout << change [i] << " ";
	cout << endl;
	*/
	bool old = false;
	for (int i = 0 ; i < k ; i ++)
	{
		/*for (int lvl = 0 ; lvl < 4 ; lvl ++)
		{
			for (int i = (1 << (lvl)) ; i < (1 << (lvl+1)) ; i ++)
				cout << my_bit.v [i].first << " ";
			cout << endl;
		}*/
		int a, b;
		cin >> a >> b; a --; b --;
		if (a != b)
			old = true;
		if (old)
		{
			old_one::rotate (a, b);
			cout << old_one::calc () << endl;
		}
		else
		{
			my_bit.checked_update (a, b);
			cout << mabs (1 + my_bit.get_top ()) << endl;
		}
	}
	/*for (int lvl = 0 ; lvl < 4 ; lvl ++)
	{
		for (int i = (1 << (lvl)) ; i < (1 << (lvl+1)) ; i ++)
			cout << my_bit.v [i].first << " ";
		cout << endl;
	}*/
}

