#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long n, k;
string commands;
namespace thirdsubtask {
	struct bit
	{
		vector < pair < int, bool > > v;
	private:
		void _update (int a, bool prev = false)
		{
			if (a < v [0].first)
				v [a * 2].second = v [a * 2 + 1].second = true;
			int new_value = -v [a].first;
			if (prev)
				new_value = -v [a - 1].first;
			int diff = new_value - v [a].first;
			while (a > 0)
			{
				v [a].first += diff;
				a /= 2;
			}
		}
	public:
		bit (int* a, int n)
		{
			int elements = 1;
			for ( ; elements < n ; elements *= 2) {}
			v.resize (elements * 2);
			for (int i = 0 ; i < elements ; i ++)
				v [i + elements] = {a [i], false};
			for (int i = elements - 1; i >= 1 ; i --)
				v [i] = {v [2 * i].first + v [2 * i + 1].first, false};
			v [0] = {elements, false};
		}
		
		void checked_update (int a, int b)
		{
			if (commands [a] == 'o')
				checked_update (a + 1, b);
			else if (commands [b + 1] == 'o')
			{
				update (a, b);
				for (int i = b + 1 ; commands [i] == 'o' ; i ++)
					_update (v [0].first + i, true);
			}
			else
			{
				update (a, b);
			}	
			
		}
		
		void update (int a, int b, int ind = 1, int lvl = 0)
		{
			if (v [ind].second == true)
			{
				if (ind < v [0].first)
					v [ind * 2].second = v [ind * 2 + 1].second = true;
				v [ind].first *= -1;
			}
			int t = ind - (1 << (lvl));
			//cout << t << " " << ind << " " << lvl << endl;
			int s = t * (v.size () / 2 / (1 << lvl));
			int e = (t + 1) * (v.size () / 2 / (1 << lvl)) - 1;
		
			//cout << "mission: " << a << " " << b << " / " << s << " " << e << endl;
			//if (a < 0 or b < 0 or s < 0 or e < 0)
			//	return;
			int mid = (s + e) / 2;
			if (a == s and b == e)
			{
				//v [ind].first = -v [ind].first;
				_update (ind);
			}
			else if (s <= a and b <= mid)
			{
				//cout << "left" << endl;
				update (a, b, ind * 2, lvl + 1);
			}
			else if (s <= a and a <= mid and mid < b)
			{
				//cout << "left" << endl;
				update (a, mid, ind * 2, lvl + 1);
				//cout << "right" << endl;
				update (mid + 1, b, ind * 2 + 1, lvl + 1);
			}
			else if (mid < a and b <= e)
			{
				//cout << "right" << endl;
				update (a, b, ind * 2 + 1, lvl + 1);
			}
			//else
				//cout << "mission failed: " << a << " " << b << " / " << s << " " << e << endl;
		}
		int get_top () const
		{
			return v [1].first;
		}
	};
}

int change [500000];

int mabs (long long  a)
{
	return (a + n * n) % n;
}

int mround (long long a)
{
	if (a <= -n)
		return a + n;
	if (a >= n)
		return a - n;
	return a;
}

namespace first2subtasks {
	void rotate (int s, int e)
	{
		for (int i = s ; i <= e ; i ++)
			if (commands [i] == '+')
				commands [i] = '-';
			else if (commands [i] == '-')
				commands [i] = '+';
	}

	int calc ()
	{
		int prev_channel = -1;
		int channel = 0;
		for (auto& x : commands)
		{
			if (x == 'o')
			{
				swap (prev_channel, channel);
			}
			else if (x == '+')
			{
				prev_channel = channel;
				channel = (channel + 1 + n) % n;
			}
			else if (x == '-')
			{
				prev_channel = channel;
				channel = (channel - 1 + n) % n;
			}
		}
		return channel + 1;
	}
}

int main ()
{
	cin.tie (nullptr);
	ios::sync_with_stdio (false);	
	cin >> n >> k;
	cin >> commands;
	bool thereareOs = false;
	for (size_t i = 0 ; i < commands.size () ; i ++)
	{
		if (commands [i] == '+')
		{
			change [i] = 1;
		}
		else if (commands [i] == '-')
		{
			change [i] = -1;
		}
		else if (commands [i] == 'o')
		{
			change [i] = -change [i - 1];
			thereareOs = true;
		}
	}
	thirdsubtask::bit my_bit = thirdsubtask::bit (change, commands.size ());
	bool first_and_second_subtasks = (commands.size () <= 1000 and k <= 1000);
	for (int i = 0 ; i < k ; i ++)
	{
		int a, b;
		cin >> a >> b; a --; b --;
		if (first_and_second_subtasks) // first 2 subtasks
		{
			first2subtasks::rotate (a, b);
			cout << first2subtasks::calc () << endl;
		}
		else if (a == b and not thereareOs) // third subtask
		{
			my_bit.checked_update (a, b);
			cout << mabs (1 + my_bit.get_top ()) << endl;
		}
	}
}

