#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 5e5 + 5;

int n,q;
int sz;
string s,temps;

int nxt[N];

int seg[N*4],lazy[N*4];
void refresh(int pos,int low,int high)
{
    if(!lazy[pos])
        return;

    //seg[pos] = (high - low + 1) - seg[pos];
    seg[pos] = -seg[pos];

    if(low != high)
    {
        lazy[pos * 2] ^= 1;
        lazy[pos * 2 + 1] ^= 1;
    }

    lazy[pos] = 0;
}

void update(int pos,int low,int high,int l,int r) /// reverses interval l to r
{
    refresh(pos, low, high);

    if(l > high  || r < low)
     return;

    if(l <= low && r >= high)
    {
      lazy[pos] ^= 1;
      refresh(pos, low, high);

      return;
    }

    int mid = (low + high) / 2;

    update(pos * 2, low, mid, l, r);
    update(pos * 2 + 1, mid + 1, high, l, r);

    seg[pos] = seg[pos * 2] + seg[pos * 2 + 1];
}

int query(int pos,int low,int high,int l,int r)
{
    refresh(pos, low, high);

    if(l > high || r < low)
      return 0;
    if(l <= low && r >= high)
        return seg[pos];

    int mid = (low + high) / 2;

    return query(pos * 2, low, mid, l, r) + query(pos * 2 + 1, mid + 1, high, l, r);
}

void build_tree(int pos,int low,int high)
{
    if(low == high)
    {
        if(temps[low] == '+')
            seg[pos] = 1;
        else
            seg[pos] = -1;

        return;
    }

    int mid = (low + high) / 2;

    build_tree(pos * 2, low, mid);
    build_tree(pos * 2 + 1, mid + 1, high);

    seg[pos] = seg[pos * 2] + seg[pos * 2 + 1];
}

void upd(int l,int r)
{
    l = nxt[l];
    if(l > r)
        return;

    if(r < sz)
    {
        if(s[r + 1] == 'o')
            update(1, 1, sz, r + 1, r + 1);
    }

    update(1, 1, sz, l, r);
}

int ans;

int main()
{
   ios_base::sync_with_stdio(false);
   cin.tie(NULL);
   cout.tie(NULL);

   int i;
   int l,r;

   cin >> n >> q;
   cin >> s;

   sz = s.size();
   s = 'X' + s;

   if(s[(int)s.size() - 1] == 'o')
    nxt[(int)s.size() - 1] = (int)s.size();
   else
    nxt[(int)s.size() - 1] = (int)s.size() - 1;

   for(i=(int)s.size() - 2;i>0;i--)
   {
       if(s[i] != 'o')
        nxt[i] = i;
       else
        nxt[i] = nxt[i+1];
   }


   for(i=0;i<s.size();i++)
   {
       if(s[i] == 'o')
       {
           if(temps[i-1] == '+')
            temps.pb('-');
           else
            temps.pb('+');
       }
       else
       {
         temps.pb(s[i]);
       }
   }

   build_tree(1,1,sz);

   while(q--)
   {
      cin >> l >> r;

      upd(l,r);

      ans = 1 + query(1,1,sz,1,sz);
      ans = ((ans % n) + n) % n;

      if(ans == 0)
        ans = n;

      cout << ans << endl;
   }



   return 0;
}


/*

10 2
+--++
1 2
2 5

*/

/*

8 3
+o-+o+
3 5
1 6
1 3

*/

/*

5 2
++oo
3 4
2 3

*/
