#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <queue>
#include <fstream>
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 1e3 + 5;
const int INF = 1e9;

int n,k;
bool cat[N][42];

struct edge{

  int to;
  int cost;

  edge() {}
  edge(int _to,int _cost) { to = _to; cost = _cost; }

};

bool vis[N];
vector <edge> nb[N];

void add_edge(int u,int v)
{
    int i;

    for(i=1;i<=k+1;i++)
    {
        if(cat[u][i] && cat[v][i])
        {
            nb[u].pb(edge(v,i));
            nb[v].pb(edge(u,i));

            break;
        }
    }
}

int ans;

priority_queue <pair <int,int> > pq;
int d[N];
void MST()
{
  int i;

  d[1] = 0;
  for(i=2;i<=n;i++)
    d[i] = INF;

  int v,cost;

  pq.push(mp(0, 1));
  while(!pq.empty())
  {
      while(vis[pq.top().second])
      {
          pq.pop();

          if(pq.empty())
            break;
      }

      if(pq.empty())
        break;

      v = pq.top().second;
      cost = -pq.top().first;

      vis[v] = true;
      ans += cost;

      pq.pop();

      for(i=0;i<nb[v].size();i++)
      {
         int to = nb[v][i].to;
         cost = nb[v][i].cost;

         if(cost < d[to])
         {
             d[to] = cost;
             pq.push(mp(-cost, to));
         }
      }
  }
}

int main()
{
   ios_base::sync_with_stdio(false);
   cin.tie(NULL);
   cout.tie(NULL);

   //freopen("techno.txt","r",stdin);

   int i,j;
   int r,x;

   cin >> n >> k;
   for(i=1;i<=n;i++)
   {
       cin >> r;
       for(j=1;j<=r;j++)
       {
           cin >> x;
           cat[i][x] = true;
       }
       cat[i][k+1] = true;
   }

   for(i=1;i<=n;i++)
   {
       for(j=i+1;j<=n;j++)
       {
           add_edge(i,j);
       }
   }

   MST();

   cout << ans << endl;

   return 0;
}


/*

3 6
3 1 2 3
3 3 4 5
3 4 5 6

*/
