#include <iostream>
#include <cstdio>
#include <cstring>
#include <vector>
using namespace std;

const int N=(1e6)+5;

int a[N],tree[4*N],lazy[4*N];
char ch[N];
vector <int> v;

void Build(int node,int low,int high)
{
  if(low==high)
  {
   tree[node]=a[low];
   return;
  }

 Build(node*2,low,(low+high)/2);
 Build(node*2+1,(low+high)/2+1,high);
 tree[node]=tree[node*2]+tree[node*2+1];
}

void Refresh(int node,int low,int high)
{
  if(low==high)
  {
    if(lazy[node]%2==1)
     tree[node]=-tree[node];

   lazy[node]=0;
   return;
  }

  if(lazy[node]%2==1)
   tree[node]=-tree[node];

 lazy[node*2]+=lazy[node];
 lazy[node*2+1]+=lazy[node];
 lazy[node]=0;
}

void Update(int node,int low,int high,int l,int r)
{
 Refresh(node,low,high);

  if(low>r || high<l)
   return;

  if(low>=l && high<=r)
  {
   lazy[node]++;
   Refresh(node,low,high);
   return;
  }

 Update(node*2,low,(low+high)/2,l,r);
 Update(node*2+1,(low+high)/2+1,high,l,r);
 tree[node]=tree[node*2]+tree[node*2+1];
}

int Query(int node,int low,int high,int l,int r)
{
 Refresh(node,low,high);

  if(low>r || high<l)
   return 0;

  if(low>=l && high<=r)
   return tree[node];

 return Query(node*2,low,(low+high)/2,l,r)+Query(node*2+1,(low+high)/2+1,high,l,r);
}

int main()
{

int n,q,len,i,j,l,r,ans,cc,sz;
bool st;

scanf("%d%d",&n,&q);

scanf("%s",ch);

len=strlen(ch);

st=true;
 for(i=0;i<len;i++)
 {
   if(ch[i]=='o')
   {
    st=false;
    break;
   }

   if(ch[i]=='+')
    a[i+1]=1;
   else
    a[i+1]=-1;
 }

 if(!st)
 {
  for(i=1;i<=q;i++)
  {
   scanf("%d%d",&l,&r);

    for(j=l-1;j<=r-1;j++)
    {
     if(ch[j]=='o')
      continue;

     if(ch[j]=='-')
      ch[j]='+';
     else
      ch[j]='-';
    }

   v.clear();
   v.push_back(1);
    for(j=0;j<len;j++)
    {
     if(ch[j]=='-')
      cc=v.back()-1;

     if(ch[j]=='+')
      cc=v.back()+1;

     if(ch[j]=='o')
     {
      sz=v.size();
      cc=v[sz-2];
     }

     if(cc>n)
      cc=1;

     if(cc<1)
      cc=n;

     v.push_back(cc);
    }

   printf("%d\n",v.back());
  }

  return 0;
 }

Build(1,1,len);

 for(i=1;i<=q;i++)
 {
  scanf("%d%d",&l,&r);

  Update(1,1,len,l,r);

  ans=Query(1,1,len,1,len);
  ans%=n;

  ans++;

   if(ans<=0)
    ans=n+ans;

  printf("%d\n",ans);
 }

return 0;
}
