#include <iostream>
#include <algorithm>
#include <cstdint>
#include <vector>
using namespace std;

vector < vector <uint32_t> > office;
uint32_t k;

uint32_t find_common (const vector<uint32_t> &a, const vector<uint32_t> &b)
{
    uint32_t pa=0, pb=0;
    while(pa<a.size()&&pb<b.size())
    {
        if(a[pa]>b[pb])pb++;
        else if(a[pa]<b[pb])pa++;
        else return a[pa];
    }
    return UINT32_MAX;
}

struct edge
{
    uint32_t u, v, we;//Za Staliny, za rodiny
};

bool cmp_we_edge (const edge &a, const edge &b)//Sujuz nerushimii
{
    return a.we<b.we;
}

vector < vector < pair <uint32_t, uint32_t > > > ss;
vector <edge> e;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    uint32_t n;
    cin>>n>>k;
    office.resize(n);
    ss.resize(n);
    e.reserve((n*(n-1))>>1);
    for(uint32_t i=0; i<n; i++)
    {
        uint32_t x;
        cin>>x;
        office[i].resize(x);
        ss.reserve(n);
        for(uint32_t j=0; j<x; j++)
            cin>>office[i][j];
        sort(office[i].begin(), office[i].end());
    }

    /*
    for(uint32_t i=0; i<n; i++)
    {
        cout<<i<<": ";
        for(auto x:office[i])
            cout<<x<<' ';
        cout<<endl;
    }
    */

    for(uint32_t i=0; i<n-1; i++)
    {
        for(uint32_t j=i+1; j<n; j++)
        {
            uint32_t we=find_common(office[i], office[j]); //USSR <3
            if(we==UINT32_MAX)we=k+1;
            ss[i].push_back(make_pair(j, we));
            ss[j].push_back(make_pair(i, we));
            e.push_back((edge){i, j, we});
        }
    }

    for(uint32_t i=0; i<n; i++)
    {
        if(ss[i].size()!=n-1)
            while(1);
    }

    sort(e.begin(), e.end(), cmp_we_edge);

    /*
    for(uint32_t i=0; i<n; i++)
    {
        cout<<i<<": ";
        for(uint32_t j=0; j<ss[i].size(); j++)
        {
            cout<<"{"<<ss[i][j].first<<", "<<ss[i][j].second<<"} ";
        }
        cout<<endl;
    }
    */


    /*
    for(uint32_t i=0; i<e.size(); i++)
    {
        cout<<i<<": "<<e[i].u<<' '<<e[i].v<<' '<<e[i].we<<endl;
    }
    */
}

class disjoint_set
{
private:
    struct node
    {
        size_t rank, parent;
        node(size_t id)
        {
            rank=0;
            parent=id;
        }
        node(){}
    };

    vector<node> nodes;

public:

    void init(size_t size)
    {
        nodes.resize(size);
        for(uint32_t i=0; i<size; i++)
            nodes[i]=node(i);
    }

    size_t query(size_t id)
    {
        if(nodes[id].parent==id)return id;
        size_t q=query(nodes[id].parent);
        nodes[id].parent=q;
        return q;
    }

    void merge(size_t a, size_t b)
    {
        if(nodes[a].rank>nodes[b].rank)
        {
            nodes[b].parent=a;
        }
        else if(nodes[a].rank<nodes[b].rank)
        {
            nodes[a].parent=b;
        }
        else
        {
            nodes[b].parent=a;
            nodes[a].rank++;
        }
    }
};

uint64_t solve()
{
    uint64_t res=0;
    disjoint_set d;
    d.init(ss.size());
    //uint64_t test=0;
    for(uint32_t i=0; i<e.size(); i++)
    {
        //cout<<e[i].u<<' '<<e[i].v<<' ';
        if(d.query(e[i].u)!=d.query(e[i].v))
        {
            res+=(uint64_t)e[i].we;
            //cout<<"meging... ";
            d.merge(e[i].u, e[i].v);
            //test++;
        }
        //cout<<"merged!"<<endl;
    }
    //if(test!=(ss.size()-1))
    //   while(true);

    return res;
}

int main()
{
    init();

    /*
    disjoint_set d;
    d.init(4);
    cout<<d.query(0)<<' '<<d.query(1)<<' '<<d.query(2)<<' '<<d.query(3)<<endl;
    d.merge(0, 1);
    cout<<d.query(0)<<' '<<d.query(1)<<' '<<d.query(2)<<' '<<d.query(3)<<endl;
    d.merge(2, 0);
    cout<<d.query(0)<<' '<<d.query(1)<<' '<<d.query(2)<<' '<<d.query(3)<<endl;
    d.merge(3, 0);
    cout<<d.query(0)<<' '<<d.query(1)<<' '<<d.query(2)<<' '<<d.query(3)<<endl;
    */

    cout<<solve()<<'\n';

    return 0;
}
