#include <iostream>
using namespace std;

const int MAXN = 1048576;

struct node
{
    int val, laz;
};

int n, q, t;
string s;
node tree[MAXN << 1];
int p[MAXN >> 1];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> t >> q;
    cin >> s;
    n = s.size();

    int j = n;
    for (int i = n; i >= 1; -- i)
    {
        p[i] = j;
        if (s[i - 1] != 'o') j = i - 1;
        //cout << p[i] << endl;
    }
    //cout << endl;

    for (int i = 0; i < n; ++ i)
    {
        if (s[i] == 'o')
        {
            s[i] = (s[i - 1] == '+') ? '-' : '+';
        }
    }
}

void build(int v = 1, int l = 1, int r = n)
{
    if (l == r)
    {
        tree[v].val = (s[l - 1] == '+') ? +1 : -1;
        return;
    }

    int mid = (l + r) >> 1;
    build(v << 1 | 0, l, mid + 0);
    build(v << 1 | 1, mid + 1, r);

    tree[v].val = tree[v << 1 | 0].val + tree[v << 1 | 1].val;
}

void update(int le, int ri, int v = 1, int l = 1, int r = n)
{
    if (tree[v].laz != 0)
    {
        tree[v].val *= -1;
        tree[v].laz = 0;
        if (l != r)
        {
            tree[v << 1 | 0].laz ^= 1;
            tree[v << 1 | 1].laz ^= 1;
        }
    }

    if (ri < l or le > r) return;
    if (le <= l and r <= ri)
    {
        tree[v].val *= -1;
        if (l != r)
        {
            tree[v << 1 | 0].laz ^= 1;
            tree[v << 1 | 1].laz ^= 1;
        }
        return;
    }

    int mid = (l + r) >> 1;
    update(le, ri, v << 1 | 0, l, mid + 0);
    update(le, ri, v << 1 | 1, mid + 1, r);

    tree[v].val = tree[v << 1 | 0].val + tree[v << 1 | 1].val;
}

void preorder(int v = 1, int l = 1, int r = n)
{
    cout << "log: " << v << ' ' << l << ' ' << r << ' ' << tree[v].val << ' ' << tree[v].laz << endl;
    if (l != r)
    {
        int mid = (l + r) / 2;
        preorder(v << 1 | 0, l, mid + 0);
        preorder(v << 1 | 1, mid + 1, r);
    }
}

int query()
{
    int res = (tree[1].laz == 0) ? +tree[1].val : -tree[1].val;
    //cout << "!" << res << endl;
    res %= t;
    if (res >= 0) return res + 1;
    else return t + res + 1;
}

int main()
{
    Init();

    build();

    //preorder();
    //return 0;

    for (int i = 0; i < q; ++ i)
    {
        int l, r;
        cin >> l >> r;
        update(l, r);
        //preorder();
        cout << query() << endl;
    }

    return 0;
}
