#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
using namespace std;

const int MAXN = 1024;
const int MAXK = 36;

struct edge
{
    int u, v, w;
    edge(){}
    edge(int u, int v, int w)
    {
        this -> u = u;
        this -> v = v;
        this -> w = w;
    }
};

int n, k;
int a[MAXN][MAXK];
int p[MAXN], q[MAXN];

vector<edge> e;

bool cmp(edge x, edge y)
{
    return x.w < y.w;
}

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;
    for (int i = 1; i <= n; ++ i)
    {
        int m;
        cin >> m;
        for (int j = 1; j <= m; ++ j)
        {
            int x;
            cin >> x;
            a[i][x] = 1;
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = i + 1; j <= n; ++ j)
        {
            bool fl = false;
            for (int kk = 1; kk <= k; ++ kk)
            {
                if (a[i][kk] * a[j][kk] == 1)
                {
                    e.emplace_back(i, j, kk);
                    fl = true;
                    break;
                }
            }
            if (!fl)
            {
                e.emplace_back(i, j, k + 1);
            }
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        p[i] = i;
        q[i] = 1;
    }
}

int root(int x)
{
    if (p[x] == x) return x;
    else return p[x] = root(p[x]);
}

void join(int x, int y)
{
    x = root(x);
    y = root(y);

    if (q[x] > q[y])
    {
        p[x] = y;
        q[y] += q[x];
    }
    else
    {
        p[y] = x;
        q[x] += q[y];
    }
}

int main()
{
    Init();

    sort(e.begin(), e.end(), cmp);

    int cnt = 0, ans = 0;
    for (int i = 0; i < e.size(); ++ i)
    {
        if (cnt == n - 1) break;

        if (root(e[i].u) != root(e[i].v))
        {
            ans += e[i].w;
            cnt++;
            join(e[i].u, e[i].v);
        }
    }

    cout << ans << endl;
    return 0;
}
