#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <stack>
#include <cctype>
#include <queue>
#include <utility>
#define INF ((1<<30)-1)*2
using namespace std;

int n, k;
int best=INF;
struct Offices
{
    int r;
    int e[32];
};
Offices a[1024];

struct For_Vector
{
    int office;
    int price;
};
vector <For_Vector> v[1024];

bool vis[1024];

bool Binary_Search (int l, int r, int x, int off)
{
    if (l>r)
        return false;
    if (l==r)
    {
        if (a[off].e[l]==x) return true;
        else return false;
    }
    int m=(l+r)/2;
    if (x==a[off].e[l] || x==a[off].e[r] || x==a[off].e[m]) return true;
    if (x<m) return Binary_Search (l+1, m-1, x, off);
    else return Binary_Search (m+1, r-1, x, off);
}

void Init ()
{
    cin>>n>>k;
    for (int i=0; i<n; i++)
    {
        cin>>a[i].r;
        for (int j=0; j<a[i].r; j++)
            cin>>a[i].e[j];
    }
}

void Find_Edges ()
{
    for (int i=0; i<n-1; i++)
        for (int ij=i+1; ij<n; ij++)
        {
            For_Vector jv, jv1;
            jv.office=ij;
            jv1.office=i;
            bool flag=false;
            for (int j=0; j<a[i].r; j++)
            {
                if (Binary_Search (0, a[ij].r-1, a[i].e[j], ij))//1st->left; 2nd->right; 3rd->looked for; 4th->office
                {
                    jv.price=a[i].e[j];
                    jv1.price=a[i].e[j];
                    flag=true;
                    j=a[i].r;
                }
            }
            if (flag==false)
            {
                jv.price=k+1;
                jv1.price=k+1;
            }
            v[i].push_back (jv);
            if (i!=0)
                v[ij].push_back (jv1);
        }
}

bool cmp (For_Vector A, For_Vector B)
{
    return A.price<B.price;
}

void Bubble_Sort (int pos)
{
    for (int i=1; i<v[pos].size (); i++)
    {
        int j=i;
        while (v[pos][j].price<v[pos][j-1].price && j>0)
        {
            swap (v[pos][j], v[pos][j-1]);
            j++;
        }
    }
}

int Find_A_Solution ()
{
    int sum=0;
    for (int i=1; i<n; i++)
        vis[i]=false;
    vis[0]=true;
    for (int i=0; i<n; i++)
        Bubble_Sort (i);
    int comes_from=0;
    int goes_to=v[0][0].office;
    sum+=v[0][0].price;
    for (int i=1; i<n; i++)
    {
        int comes_from=goes_to;
        int j=0;
        while (vis[v[comes_from][j].office])
            j++;
        goes_to=v[comes_from][j].office;
        if (i!=n-1)
            sum+=v[comes_from][j].price;
        vis[v[comes_from][j].office]=true;
    }
    return sum;
}

int main ()
{
    Init ();
    Find_Edges ();
    cout<<Find_A_Solution ()<<endl;
    return 0;
}
