#include <algorithm>
#include <iostream>
#include <cstdio>
using namespace std;

#define NMax 1000
#define KMax 32

struct edge
{
    int v1,v2,tg;

    edge(){};
    edge(int a,int b,int c)
    {
        v1=a,v2=b,tg=c;
    }
} edges[NMax*NMax];

int n,k,cnt,cur,x,ans,par[NMax*NMax+2],h[NMax*NMax+2];
bool cat[NMax+2][KMax+2];

int find_root(int a)
{
    if(par[a]==a)return a;
    return par[a]=find_root(par[a]);
}

void unite(edge a)
{
    int k1=find_root(a.v1),k2=find_root(a.v2);
    if(k1==k2)return ;

    if(h[k1]<h[k2])par[k1]=k2;
    else if(h[k1]>h[k2])par[k2]=k1;
    else par[k1]=k2,h[k2]++;

    ans+=a.tg;
}

bool cmp(edge a,edge b)
{
    return a.tg<b.tg;
}

int main()
{
    scanf("%d%d",&n,&k);

    for(int i=1;i<=n;i++)
    {
        scanf("%d",&cnt);
        for(int j=0;j<cnt;j++)
        {
            scanf("%d",&cur);
            cat[i][cur]=1;
        }
    }

    for(int i=1;i<=n;i++)
    {
        for(int j=i+1;j<=n;j++)
        {
            bool broken=0;
            for(int t=1;t<=k;t++)
                if(cat[i][t]==1&&cat[j][t]==1)
                {
                    edges[x++]=edge(i,j,t);
                    broken=1;
                    break;
                }
            if(broken==0)edges[x++]=edge(i,j,k+1);
        }
    }

    /**for(int i=0;i<x;i++)
        cout<<edges[i].v1<<" "<<edges[i].v2<<" "<<edges[i].tg<<endl;*/

    for(int i=1;i<=x*(x-1)/2;i++)
        par[i]=i;

    sort(edges,edges+x,cmp);

    for(int i=0;i<x;i++)
        unite(edges[i]);

    printf("%d\n",ans);


    return 0;
}
