#include <iostream>
#include <string>
using namespace std;
const int maxN=1000010;
int n,q,m,arr[maxN],segtree[4*maxN],lazy[4*maxN];
string s;
void build(int nd,int le,int ri)
{
    if(le==ri){
        segtree[nd]=arr[le];
        return;
    }
    int mid=(le+ri)>>1;
    build(2*nd,le,mid);
    build(2*nd+1,mid+1,ri);
    segtree[nd]=segtree[2*nd]+segtree[2*nd+1];
}
void updateLazy(int nd,int le,int ri)
{
    if(lazy[nd]==0)return;
    //int mid=(le+ri)>>1;
    if(le!=ri){
        lazy[2*nd]+=lazy[nd];
        lazy[2*nd+1]+=lazy[nd];
        if(lazy[2*nd]%2==1)segtree[2*nd]=-segtree[2*nd];
        if(lazy[2*nd+1]%2==1)segtree[2*nd+1]=-segtree[2*nd+1];
    }
    lazy[nd]=0;
}
void update(int nd,int le,int ri,int p,int q)
{
    updateLazy(nd,le,ri);
    if(le>q || ri<p)return;
    if(le>=p && ri<=q){
        segtree[nd]=-segtree[nd];
        lazy[nd]++;
        return;
    }
    int mid=(le+ri)>>1;
    update(2*nd,le,mid,p,q);
    update(2*nd+1,mid+1,ri,p,q);
    segtree[nd]=segtree[2*nd]+segtree[2*nd+1];
}
void printTree(int nd,int le,int ri)
{
    cout<<nd<<" "<<le<<" "<<ri<<" "<<segtree[nd]<<" "<<lazy[nd]<<endl;
    if(le==ri)return;
    int mid=(le+ri)>>1;
    printTree(2*nd,le,mid);
    printTree(2*nd+1,mid+1,ri);
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int i,j,a,b;
    cin>>n>>q;
    cin>>s;
    m=s.size();
    for(i=0;i<m;i++)
    {
        if(s[i]=='+')arr[i]=1;
        else if(s[i]=='-')arr[i]=-1;
    }
    build(1,0,m-1);
    for(i=0;i<q;i++)
    {
        cin>>a>>b;
        update(1,0,m-1,a-1,b-1);
        ///printTree(1,0,m-1);
        int t=(1+segtree[1]+n)%n;
        if(t==0)t=n;
        cout<<t<<endl;
    }
}
/**
10 4
+--++-
3 4
1 5
2 3
5 6
-------
10 4
+--++-
1 5
2 3
5 6
3 4
----
10 2
++++
1 3
3 4
*/
