#include <bits/stdc++.h>

using namespace std;

struct edge
{
    int from, to, c;

    edge(int _from, int _to, int _c)
    {
        from = _from;
        to = _to;
        c = _c;
    }

    bool operator<(edge other) const
    {
        return c > other.c;
    }
};

const int MAXN = 1001;

int n, k;
vector<int> a[MAXN];
int parent[MAXN];
priority_queue <edge> edges;

int getCena(int f, int s)
{
    int s1 = a[f].size(), s2 = a[s].size();
    int l = 0, r = 0;
    while(l < s1 && r < s2)
    {
        if(a[f][l] == a[s][r])
        {
            return a[f][l];
        }
        else if(a[f][l] < a[s][r])
        {
            l++;
        }
        else
        {
            r++;
        }
    }
    return k + 1;
}

void makeEdges()
{
    for(int i = 0; i < n; i++)
    {
        for(int j = i + 1; j < n; j++)
        {
            int cena = getCena(i, j);
            edges.push(edge(i, j, cena));
        }
    }
}

int getRoot(int node)
{
    if(node == parent[node])
    {
        return node;
    }
    return parent[node] = getRoot(parent[node]);
}

int kruskal()
{
    for(int i = 0; i < n; i++)
    {
        parent[i] = i;
    }
    int ans = 0;
    while(!edges.empty())
    {
        edge current = edges.top(); edges.pop();
        int p1 = getRoot(current.from);
        int p2 = getRoot(current.to);
        if(p1 != p2)
        {
            parent[p1] = p2;
            ans += current.c;
        }
    }
    return ans;
}

int main()
{
    scanf("%d %d", &n, &k);

    for(int i = 0; i < n; i++)
    {
        int r;
        scanf("%d", &r);
        for(int j = 0; j < r; j++)
        {
            int z;
            scanf("%d", &z);
            a[i].push_back(z);
        }
    }
    makeEdges();
    printf("%d\n", kruskal());

    return 0;
}

/*
3 6
3 1 2 3
3 3 4 5
3 4 5 6

7
*/

/*
3 6
3 1 2 3
2 4 5
3 4 5 6
*/
