#include <bits/stdc++.h>

using namespace std;

const int MAXL = 500000;

const int tSize = 524288 * 2;
int n, q, l;
char str[MAXL];
int tree[tSize];

int getIndex(int index)
{
    return (tSize >> 1) + index + 1;
}

void buildTree()
{
    for(int i = 0; i < l; i++)
    {
        if(str[i] == '+')
        {
            tree[getIndex(i)] = 1;
        }
        else if(str[i] == '-')
        {
            tree[getIndex(i)] = -1;
        }
        else
        {
            tree[getIndex(i)] = tree[getIndex(i) - 1] == 1? -1 : 1;
        }
    }
    for(int i = (tSize / 2) - 1; i >= 1; i--)
    {
        tree[i] = tree[i * 2] + tree[(i * 2) + 1];
    }
}

void update(int index, int delta)
{
    index = getIndex(index);
    for(index; index >= 1; index = index / 2) tree[index] += delta;
}

int query(int from, int to)
{
    if(from > to) return 0;
    int fIndex = getIndex(from);
    int tIndex = getIndex(to);
    if(fIndex == tIndex) return tree[fIndex];
    int ans = tree[fIndex] + tree[tIndex];
    while(fIndex + 1 != tIndex)
    {
        if(fIndex % 2 == 0) ans += tree[fIndex + 1];
        if(tIndex % 2 == 1) ans += tree[tIndex - 1];
        fIndex /= 2; tIndex /= 2;
    }
    return ans;
}

int main()
{
    scanf("%d %d", &n, &q);
    cin >> str;
    vector < pair<int, int> > tasks;
    for(int i = 0; i < q; i++)
    {
        int v, w;
        scanf("%d %d", &v, &w);
        tasks.push_back(make_pair(v, w));
    }
    l = strlen(str);
    buildTree();
    /*for(int i = 0; i < l; i++)
    {
        printf("%d ", tree[getIndex(i)]);
    }
    printf("\n");*/
    /*
    update(1, 2);
    printf("%d\n", query(0, 1));*/
    for(int i = 0; i < q; i++)
    {
        int v = tasks[i].first, w = tasks[i].second;
        v--; w--;
        int ans = 0;
        bool changed = false;
        for(int j = v; j <= w; j++)
        {
            int delta = 0;
            if(str[j] != 'o')
            {
                changed = true;
                delta = tree[getIndex(j)] == -1? 2 : -2;
            }
            else
            {
                if(changed)
                delta = tree[getIndex(j) - 1] == -1? 2 : -2;
            }
            update(j, delta);
            ans += tree[getIndex(j)];
        }
        if(w + 1 < l && str[w + 1] == 'o')
        {
            for(int j = w + 1; j < l && str[j] == 'o'; j++)
            {
                int delta = 0;
                if(changed)
                    delta = tree[getIndex(j) - 1] == -1? 2 : -2;
                update(j, delta);
            }
        }
        /*for(int i = 0; i < l; i++)
        {
            printf("%d ", tree[getIndex(i)]);
        }
        printf("\n");*/
        int sum = ans + query(0, v - 1) + query(w + 1, l - 1);
        while(sum <= 0) sum += n;
        printf("%d\n", (sum % n) + 1);
    }

    return 0;
}

/*
10 2
+--++
1 2
2 5

2
8
*/

/*
8 3
+o-+o+
3 5
1 6
1 3

3
7
1
*/

/*
5 2
++oo
3 4
2 3

3
1
*/

/*
10 2
+--++
1 1
1 1
*/

/*
5 2
+o-o
3 3
2 2
*/

/*
5 1
+o-o
2 2
*/

/*
5 1
++ooo
2 2

2
*/
